import com.cycling74.max.*;
import java.io.*;


// 2011 - Dec 28 - Lasse Juul Kolding

/**
 * Based on "filesys" by Patrick Delges
 * ---Adding Copy functionality.
 * 
 * @author pdelges_at_radiantslab_dot_com
 *
 * remove or rename a file, and more
 *
 */

public class flex_fsys extends MaxObject {

	public flex_fsys() { 
		declareInlets(new int [] {DataTypes.MESSAGE});
		declareOutlets(new int [] {DataTypes.INT});
		createInfoOutlet(false);
		}

	
	public void rm (String s) {

		File f = new File(MaxSystem.maxPathToNativePath(s));
		if (f.exists()) {
 			outlet (0, f.delete());
 			}
 		else {
 			outlet (0, 0);
 		}
	}
	
	public void exists (String s) {

		File f = new File(MaxSystem.maxPathToNativePath(s));
 		outlet (0, (f.exists()));
 	}

	public void mkdir (String s) {

		File f = new File(MaxSystem.maxPathToNativePath(s));
 		outlet (0, f.mkdir());
 	}


	
	public void mv (String oldName, String newName) {
		File of = new File (MaxSystem.maxPathToNativePath(oldName));
		File nf = new File (MaxSystem.maxPathToNativePath(newName));
		
		if (of.exists()) {
			outlet (0, of.renameTo(nf));
			}
		else {
			outlet (0, -1);
		}
	}
	
	
	public void cp (String source, String target)
			throws IOException{
		File orf = new File (MaxSystem.maxPathToNativePath(source));
		File nef = new File (MaxSystem.maxPathToNativePath(target));
        
		if (orf.exists()) {
			
			InputStream in = new FileInputStream(orf);
            OutputStream out = new FileOutputStream(nef);
			
			// Copy the bits from instream to outstream
            byte[] buf = new byte[1024];
            int len;
            while ((len = in.read(buf)) > 0) {
                out.write(buf, 0, len);
            }
			
           in.close();
           out.close();
           
           outlet (0, 1);
			
		}
		else {
			outlet (0, -1);
		}
	}


}
